unit Crypt;

interface

uses windows, sysutils, math, graphics, filectrl;

type
  TRGB=record
  b,g,r : byte;
end;

Type
    ARGB=array [0..1] of TRGB;
    PARGB=^ARGB;

const
  BufferSize = 3*4*4096;
Type
  PBuffer = ^TBuffer;
  TBuffer = array [1..BufferSize] of Byte;

function stringtocrypt(s : string):string;
function crypttostring(s : string):string;
function stringxorcryptpass(s : string; pass : string):string;
procedure cryptfile(filenameout : string; filenamein : string; count : integer);
procedure decryptfile(filenameout : string; filenamein : string; count : integer);
function loadcryptimage(filename : string; count : integer):Tbitmap;
procedure CryptFileWithPass(OutFile, InFile : String; Pass : String);
procedure DeCryptFileWithPass(OutFile, InFile : String; Pass : String);
function loadcryptimageWithPass(filename : string; pass : string):Tbitmap;
function loadbitmap24bitfromfilewithpass(filename : string; pass : string):TBitmap;

implementation

function getdirectory(filename:string):string;
var i,n:integer;
begin
 n:=0;
 for i:=length(filename) downto 1 do
 If filename[i]='\' then
 begin
  n:=i;
  break;
 end;
 delete(filename,n,length(filename)-n+1);
 result:=filename;
end;

Function hextointdef(hex:string;default:integer):integer;
var s:string;
int,i:integer;
begin
int:=0;
If length(hex)>0 then If hex[1]='$' then delete(hex,1,1);
If length(hex)>0 then begin
For i:=1 to length(hex) do begin
s:=s+' ';
s[i]:=hex[length(hex)+1-i];
end;
For i:=1 to length(hex) do
Case Upcase(s[i]) of
'0': int:=int;
'1': int:=int+round(intpower(16,i-1));
'2': int:=int+2*round(intpower(16,i-1));
'3': int:=int+3*round(intpower(16,i-1));
'4': int:=int+4*round(intpower(16,i-1));
'5': int:=int+5*round(intpower(16,i-1));
'6': int:=int+6*round(intpower(16,i-1));
'7': int:=int+7*round(intpower(16,i-1));
'8': int:=int+8*round(intpower(16,i-1));
'9': int:=int+9*round(intpower(16,i-1));
'A': int:=int+10*round(intpower(16,i-1));
'B': int:=int+11*round(intpower(16,i-1));
'C': int:=int+12*round(intpower(16,i-1));
'D': int:=int+13*round(intpower(16,i-1));
'E': int:=int+14*round(intpower(16,i-1));
'F': int:=int+15*round(intpower(16,i-1));
else begin int:=default; break; end;
end;
end else int:=default;
result:=int;
end;

function sml(b : byte; c:integer):byte;
var i:integer;
tb : byte;
begin
 tb:=b;
 for i:=1 to c do
 asm
  mov al,tb
  and al,$80
  shl tb,1
  shr al,7
  add tb,al
 end;
 result:=tb;
end;


function smr(b : byte; c:integer):byte;
var i:integer;
tb : byte;
begin
tb:=b;
for i:=1 to c do
 asm
  mov al,tb
  and al,1
  shr tb,1
  shl al,7
  add tb,al
 end;
 result:=tb;
end;

function bytetohex(b : byte; format : integer) : string;
var i:integer;
begin
  i:=b;
  result:=inttohex(i,format);
end;

function stringtocrypt(s : string):string;
var i:integer;
sm, b, m1,m2 : byte;
begin
m1:=random($ff+1);
m2:=random($ff+1);
result:=bytetohex(m1,2)+bytetohex(m2,2);
 for i:=1 to length(s) do
 begin
    b:=ord(s[i]);
    sm:=random($f+1);
    b:=sml(b,sm);
    result:=result+bytetohex(sm,1)+bytetohex(b,2)+bytetohex(random($f+1),1);
 end;
 for i:=1 to ((m1 shl 7) shr 7)+m2 shl 1 do
  result:=result+bytetohex(random($f+1),1);
end;

function crypttostring(s : string):string;
var i:integer;
sm, b, m1, m2 : byte;
mo : integer;
begin
result:='';
 m1:=hextointdef(s[1]+s[2],0);
 m2:=hextointdef(s[3]+s[4],0);
 mo:=((m1 shl 7) shr 7)+m2 shl 1;
 delete(s,length(s)-mo,mo);
 delete(s,1,4);
 for i:=1 to length(s) div 4 do
  begin
    sm:=hextointdef(s[(i-1)*4+1],0);
    b:=hextointdef(s[(i-1)*4+2]+s[(i-1)*4+3],0);
    b:=smr(b,sm);
    result:=result+chr(b);
  end;
end;

function stringxorcryptpass(s : string; pass : string):string;
var i,j,l:integer;
ch, chp : char;
begin
result:=s;
l := length(s);
for i:=1 to length(s) div length(pass)+1 do
begin
  for j:=1 to length(pass) do
  begin
    if (i-1)*length(pass)+j>l then exit;
    ch:=s[(i-1)*length(pass)+j];
    chp:=pass[j];
    ch:=chr(ord(ch) xor ord(chp));
    result[(i-1)*length(pass)+j]:=ch;
  end;
end;
{for i:=round((length(s) div length(pass))*length(pass)) to length(s) do
begin }
{    for j:=1 to length(s)-round((length(s) div length(pass))*length(pass)) do
  begin
    ch:=s[(i-1)*length(pass)+j];
    chp:=pass[j];
    ch:=chr(ord(ch) xor ord(chp));
    result[(i-1)*length(pass)+j]:=ch;
  end;    }
//  end;
end;

procedure cryptfile(filenameout : string; filenamein : string; count : integer);
var
  Size             : integer;
  Buffer           : PBuffer;
  infile, outfile  : File;
  i,j:integer;
  ch,t:byte;
  b : tbitmap;
begin
     buffer := Nil;
   AssignFile(infile, filenameout);
   System.Reset(infile, 1);
   AssignFile(outfile, filenamein);
   System.Rewrite(outfile, 1);
   New(Buffer);
   BlockRead(infile, Buffer^, BufferSize, Size);
     for i:=1 to BufferSize do
  begin
 ch:=buffer[i];
 for j:=1 to count do
 asm
 mov al,&ch
 and al,1
 shr &ch,1
 shl al,7
 add &ch,al
 not &ch
 end;
  buffer[i]:= ch;
  end;
  BlockWrite(outfile,Buffer^, Size);
  System.close(outfile);
  System.close(infile);
end;

procedure decryptfile(filenameout : string; filenamein : string; count : integer);
var
  Size             : integer;
  Buffer           : PBuffer;
  infile, outfile  : File;
  i,j:integer;
  ch,t:byte;
  b : tbitmap;
begin
     buffer := Nil;
   AssignFile(infile, filenameout);
   System.Reset(infile, 1);
   AssignFile(outfile, filenamein);
   System.Rewrite(outfile, 1);
   New(Buffer);
   BlockRead(infile, Buffer^, BufferSize, Size);
     for i:=1 to BufferSize do
  begin
 ch:=buffer[i];
 for j:=1 to count do
 asm
 mov al,&ch;
 and al,$80;
 shl &ch,1;
 shr al,7;
 add &ch,al;
 not &ch;
 end;
  buffer[i]:= ch;
  end;
  BlockWrite(outfile,Buffer^, Size);
  System.close(outfile);
  System.close(infile);
end;

function loadcryptimage(filename : string; count : integer):Tbitmap;
var
  Size             : integer;
  Buffer           : PBuffer;
  infile, outfile  : File;
  i,j:integer;
  ch,t:byte;
  b : tbitmap;
begin
   If not fileexists(filename) then exit;
   try
   b:=TBitmap.Create;
   buffer := Nil;
   AssignFile(infile, filename);
   System.Reset(infile, 1);
   AssignFile(outfile, getdirectory(filename)+'$TeMp_$$Im_a_ge$');
   System.Rewrite(outfile, 1);
   New(Buffer);
   BlockRead(infile, Buffer^, BufferSize, Size);

  for i:=1 to BufferSize do
  begin
 ch:=buffer[i];
 for j:=1 to count do
 asm
 mov al,&ch
 and al,$80
 shl &ch,1
 shr al,7
 add &ch,al
 not &ch
 end;
  buffer[i]:= ch;
  end;
  BlockWrite(outfile,Buffer^, Size);

   System.close(outfile);
   System.close(infile);
       b.LoadFromfile(getdirectory(filename)+'$TeMp_$$Im_a_ge$');
   except;
   end;
   erase(outfile);
    result:=b;
end;

procedure CryptFileWithPass(OutFile, InFile : String; Pass : String);
var
  Size             : integer;
  Buffer           : PBuffer;
  infile_, outfile_  : File;
  i,j:integer;
  ch,t:byte;
  b : tbitmap;
begin
   If not fileexists(OutFile) then exit;
   try
   b:=TBitmap.Create;
   buffer := Nil;
   AssignFile(infile_, OutFile);
   System.Reset(infile_, 1);
   AssignFile(outfile_, InFile);
   System.Rewrite(outfile_, 1);
   New(Buffer);

  repeat
   BlockRead(infile_, Buffer^, BufferSize, Size);

  for i:=1 to BufferSize div length(pass) do
  begin
 for j:=1 to length(pass) do
 begin
 buffer[round((i-1)*length(pass)+j)]:= buffer[(i-1)*length(pass)+j] xor ord(pass[j]);
 ch:=buffer[round((i-1)*length(pass)+j)];
 asm
  mov al,&ch
 and al,1
 shr &ch,1
 shl al,7
 add &ch,al
 not &ch
 end;
 buffer[round((i-1)*length(pass)+j)]:=ch;
 end;
  end;
  BlockWrite(outfile_,Buffer^, Size);

         until Size < BufferSize;
   System.close(outfile_);
   System.close(infile_);
   except;
   end;
end;

procedure DeCryptFileWithPass(OutFile, InFile : String; Pass : String);
var
  Size             : integer;
  Buffer           : PBuffer;
  infile_, outfile_  : File;
  i,j:integer;
  ch,t:byte;
  b : tbitmap;
begin
   If not fileexists(OutFile) then exit;
   try
   b:=TBitmap.Create;
   buffer := Nil;
   AssignFile(infile_, OutFile);
   System.Reset(infile_, 1);
   AssignFile(outfile_, InFile);
   System.Rewrite(outfile_, 1);
   New(Buffer);

   repeat
   BlockRead(infile_, Buffer^, BufferSize, Size);

  for i:=1 to BufferSize div length(pass) do
  begin
 for j:=1 to length(pass) do
 begin
 ch:=buffer[round((i-1)*length(pass)+j)];
 asm
 mov al,&ch
 and al,$80
 shl &ch,1
 shr al,7
 add &ch,al
 not &ch
 end;
 buffer[round((i-1)*length(pass)+j)]:=ch;
 buffer[round((i-1)*length(pass)+j)]:= buffer[(i-1)*length(pass)+j] xor ord(pass[j]);
 end;
  end;
  BlockWrite(outfile_,Buffer^, Size);
   until size<buffersize;
   System.close(outfile_);
   System.close(infile_);
   except;
   end;
end;

function loadcryptimageWithPass(filename : string; pass : string):Tbitmap;
var
  Size             : integer;
  Buffer           : PBuffer;
  infile, outfile  : File;
  i,j:integer;
  ch,t:byte;
  b : tbitmap;
begin
   If not fileexists(filename) then exit;
   try
   b:=TBitmap.Create;
   buffer := Nil;
   AssignFile(infile, filename);
   System.Reset(infile, 1);
   AssignFile(outfile, getdirectory(filename)+'$TeMp_$$Im_a_ge$');
   System.Rewrite(outfile, 1);
   New(Buffer);
   BlockRead(infile, Buffer^, BufferSize, Size);

  for i:=1 to BufferSize div length(pass) do
  begin
 for j:=1 to length(pass) do
 begin
 ch:=buffer[round((i-1)*length(pass)+j)];
 asm
 mov al,&ch
 and al,$80
 shl &ch,1
 shr al,7
 add &ch,al
 not &ch
 end;
 buffer[round((i-1)*length(pass)+j)]:=ch;
 buffer[round((i-1)*length(pass)+j)]:= buffer[(i-1)*length(pass)+j] xor ord(pass[j]);
 end;
  end;

  BlockWrite(outfile,Buffer^, Size);

   System.close(outfile);
   System.close(infile);
       b.LoadFromfile(getdirectory(filename)+'$TeMp_$$Im_a_ge$');
   except;
   end;
   erase(outfile);
   result:=TBitmap.Create;
    result.assign(b);
    b.Free;
end;

function loadbitmap24bitfromfilewithpass(filename : string; pass : string):TBitmap;
var f:file;
p:pargb;
buffer : Pbuffer;
size,h,w:integer;
h1,h2,h3,h4,w1,w2,w3,w4:integer;
i,j,k:integer;
sizedone : integer;
ch : byte;
x : array of byte;
begin
sizedone:=0;
   buffer := Nil;
   new(buffer);
   assignfile(f,filename);

   System.Reset(f, 1);
   blockread(f,buffer^,buffersize,size);

     for i:=1 to BufferSize div length(pass) do
  begin
 for j:=1 to length(pass) do
 begin
 ch:=buffer[round((i-1)*length(pass)+j)];
 asm
 mov al,&ch
 and al,$80
 shl &ch,1
 shr al,7
 add &ch,al
 not &ch
 end;
 buffer[round((i-1)*length(pass)+j)]:=ch;
 buffer[round((i-1)*length(pass)+j)]:= buffer[(i-1)*length(pass)+j] xor ord(pass[j]);
 end;
  end;


 h1:=buffer[1];
 h2:=buffer[2];
 h3:=buffer[3];
 h4:=buffer[4];
 w1:=buffer[5];
 w2:=buffer[6];
 w3:=buffer[7];
 w4:=buffer[8];
 asm
  mov eax,h4
  shl eax,8
  add eax,h3
  shl eax,8
  add eax,h2
  shl eax,8
  add eax,h1
  mov h,eax

  mov eax,w4
  shl eax,8
  add eax,w3
  shl eax,8
  add eax,w2
  shl eax,8
  add eax,w1
  mov w,eax
 end;
result:=Tbitmap.Create;
result.pixelformat:=pf24bit;
result.Width:=w;
result.Height:=h;
 setlength(x,filesize(f)-8);
  for i:=9 to size do
  x[i-9]:=buffer[i];
   sizedone:=1;
   repeat
   BlockRead(f, Buffer^, BufferSize, Size);
     if size<>0 then
     for i:=1 to BufferSize div length(pass) do
  begin
 for j:=1 to length(pass) do
 begin
 ch:=buffer[round((i-1)*length(pass)+j)];
 asm
 mov al,&ch
 and al,$80
 shl &ch,1
 shr al,7
 add &ch,al
 not &ch
 end;
 buffer[round((i-1)*length(pass)+j)]:=ch;
 buffer[round((i-1)*length(pass)+j)]:= buffer[(i-1)*length(pass)+j] xor ord(pass[j]);
 end;
  end;
   for i:=1 to size do
  x[sizedone*buffersize+i-9]:=buffer[i];
  inc(sizedone);
  until Size < BufferSize;
for i:=0 to h-1 do
begin
p:=result.ScanLine[i];
for j:=0 to w-1 do
begin
 p[j].r:=x[3*(i*w+j)];
 p[j].g:=x[3*(i*w+j)+1];
 p[j].b:=x[3*(i*w+j)+2];
end;
end;
 system.close(f);
end;

end.



